<template>
  <div class="content">
    <PageTitle>Buildings</PageTitle>
    <div class="mapBox">
      <ol-map
        id="map"
        :loadTilesWhileAnimating="true"
        :loadTilesWhileInteracting="true"
        :cluster="true"
      >
        <ol-view
          ref="view"
          :center="center"
          :rotation="rotation"
          :zoom="zoom"
          :projection="projection"
        />

        <ol-tile-layer>
          <ol-source-osm />
        </ol-tile-layer>

        <!-- <ol-interaction-clusterselect
          @select="featureSelected"
          :pointRadius="20"
        >
          <ol-style>
            <ol-style-stroke color="green" :width="5"></ol-style-stroke>
            <ol-style-fill color="rgba(255,255,255,0.5)"></ol-style-fill>
            <ol-style-icon
              :src="markerIcon"
              :scale="0.5"
              positioning="top-center"
            ></ol-style-icon>
          </ol-style>
        </ol-interaction-clusterselect> -->

        <ol-animated-clusterlayer
          @click="featureClicked"
          :animationDuration="500"
          :distance="60"
        >
          <ol-source-vector ref="vectorsource">
            <ol-feature v-for="(location, index) in locations" :key="index">
              <ol-geom-point
                :coordinates="toXY(location.lon, location.lat)"
                v-on:mouseOver="handleClick"
              ></ol-geom-point>
            </ol-feature>
          </ol-source-vector>

          <ol-style :overrideStyleFunction="overrideStyleFunction">
            <ol-style-stroke color="red" :width="2"></ol-style-stroke>
            <ol-style-fill color="rgba(255,255,255,0.1)"></ol-style-fill>

            <ol-style-circle :radius="20">
              <ol-style-stroke
                color="black"
                :width="15"
                :lineDash="[]"
                lineCap="butt"
              ></ol-style-stroke>
              <ol-style-fill color="black"></ol-style-fill>
            </ol-style-circle>

            <ol-style-text>
              <ol-style-fill color="white"></ol-style-fill>
            </ol-style-text>
          </ol-style>
        </ol-animated-clusterlayer>
      </ol-map>
      <div id="mapSidePanel">
        <div class="infoPanel">
          <p>BuildingName</p>
          <p>More info like address</p>
        </div>
        <div class="listPanel"></div>
      </div>
    </div>
  </div>
</template>

<script>
import PageTitle from "./atoms/PageTitle.vue";
import axios from "axios";
import store from "@/store/auth";
import { ref } from "vue";
import { fromLonLat } from "ol/proj";
import markerIcon from "@/assets/pin.png";

export default {
  components: { PageTitle },
  setup() {
    const center = fromLonLat([3.7099, 51.0602]);
    const zoom = ref(13.5);
    // const rotation = ref(0);

    return {
      center,
      zoom,
      markerIcon,
    };
  },
  data() {
    return {
      locations: [
        {
          name: "Location 1",
          lat: 40.7128,
          lon: -74.006,
          info: "Information about Location 1",
        },
        {
          name: "Location 2",
          lat: 34.0522,
          lon: -118.2437,
          info: "Information about Location 2",
        },
        {
          name: "Location 3",
          lat: 51.059784,
          lon: 3.707074,
          info: "Information about Location 3",
        },
      ],
      selectedLocation: null,
    };
  },
  created() {
    // this.addressToCoordinates("Gebroeders de Smetstraat 1, 9000 Gent");
  },
  mounted() {
    const map = ref(null);
    const source = map.value.getMap().getLayers().item(0).getSource();
    const features = source.getFeatures();
    console.log("Features:", features);
  },
  methods: {
    test(event) {
      console.log("test");
      console.log(event);
    },
    handleClick(event) {
      console.log("test");
      console.log(event);
    },
    toXY(lon, lat) {
      return fromLonLat([lon, lat]);
    },
    getRandomInRange(from, to, fixed) {
      return (Math.random() * (to - from) + from).toFixed(fixed) * 1;
    },
    featureSelected(event) {
      console.log(event);
    },
    featureClicked(event) {
      const feature = event.map.forEachFeatureAtPixel(
        event.pixel,
        (feature) => {
          return feature;
        }
      );
      if (feature) {
        console.log(feature.getProperties()); // Log the feature properties
      }
    },
    addressToCoordinates(address) {
      var data = {
        format: "json",
        addressdetails: 1,
        q: address,
        limit: 1,
      };
      axios
        .get("https://nominatim.openstreetmap.org", data)
        .then((response) => {
          console.log(response);
        });
    },
    overrideStyleFunction(feature, style) {
      let clusteredFeatures = feature.get("features");
      let size = clusteredFeatures.length;

      let color = size > 20 ? "192,0,0" : size > 8 ? "255,128,0" : "0,128,0";
      var radius = Math.max(8, Math.min(size, 20));
      style
        .getImage()
        .getStroke()
        .setColor("rgba(" + color + ",0.5)");
      style
        .getImage()
        .getFill()
        .setColor("rgba(" + color + ",1)");

      style.getImage().setRadius(radius);

      style.getText().setText(size.toString());
    },

    getBuildings() {
      store.commit("general/setLoading", true);
      try {
        axios.get("/api/building").then((response) => {
          if (response.status === 200) {
            this.setAndRefactor(response.data);
          }
        });
      } catch (error) {
        console.log(error);
      }
      store.commit("general/setLoading", false);
    },
    setAndRefactor(buildings) {
      this.data = [];
      buildings.forEach((building) => {
        this.data.push({
          id: building.id,
          name: building.name,
          route: building.round.name,
          stad: building.region?.name,
          student: building.student?.name,
          status: 0,
          opmerking: 0,
        });
      });
    },
  },
};
</script>

<style lang="scss" scoped>
.mapBox {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  width: 100%;
  height: 88vh;
  #map {
    flex-grow: 5;
    height: auto;
    min-width: 75%;
    min-height: 75%;
  }
  #mapSidePanel {
    flex-grow: 1;
  }
}
</style>
